#include "std.mi"
#include "pldir.mi"

Function setTempText(String txt);
Function emptyTempText();
Function String verticalizeString(String mytxt);

Global Text Songticker, visiblesongticker;
Global Slider Volbar, Seeker;
Global Int Seeking, slen, i, charheight, sheight, maxheight, defaulty, direction;
Global Group scrgrp, snggrp;
Global String vtxt;
Global GuiObject songtickerobj;
Global Float speed;
Global Boolean ismoving;

Class GuiObject HintObject;

Global HintObject Play, Stop, Previous, Next, Pause, cf, shuffle, repeat, minimize, winshadeh, exit, aot, winshaden;

System.onScriptLoaded() {
    scrgrp = getScriptGroup();
	snggrp = scrgrp.findObject("songticker.masked");
	Songticker = snggrp.getObject("realsongticker");
	visiblesongticker = snggrp.getObject("songticker");
	songtickerobj = snggrp.getObject("songticker");

	Volbar = scrgrp.getObject("volume");
	Seeker = scrgrp.getObject("seeker");
	Play = scrgrp.getObject("Play");
	Pause = scrgrp.getObject("Pause");
	Stop = scrgrp.getObject("Stop");
	Next = scrgrp.getObject("Next");
	Previous = scrgrp.getObject("Previous");
	minimize = scrgrp.getObject("minimize");
	winshadeh = scrgrp.getObject("winshadeh");
	winshaden = scrgrp.getObject("winshaden");
	cf = scrgrp.getObject("crossfade");
	shuffle = scrgrp.getObject("shuffle");
	repeat = scrgrp.getObject("repeat");
	aot = scrgrp.getObject("OnTOP");
	exit = scrgrp.getObject("close");

    charheight = 15;
    maxheight = 96;
    defaulty = 408;
    direction = 3;
    speed = 1.4;

    visiblesongticker.setText(verticalizeString(Songticker.getText()));
    songtickerobj.setXmlParam("y", System.integerToString(defaulty));

    if(sheight > maxheight){
       direction = 1;
       songtickerobj.setTargetY(defaulty-sheight+maxheight-3);
       songtickerobj.setTargetSpeed(slen/speed);
       songtickerobj.gotoTarget();
    }
}

Songticker.onTextChanged(String thetxt){
    visiblesongticker.setText(verticalizeString(thetxt));
    ismoving = songtickerobj.isGoingToTarget();
    if(ismoving) {
       songtickerobj.cancelTarget();
    }
    songtickerobj.setXmlParam("y", System.integerToString(defaulty));
    if(sheight > maxheight){
       direction = 1;
       songtickerobj.setTargetY(defaulty-sheight+maxheight-3);
       songtickerobj.setTargetSpeed(slen/speed);
       songtickerobj.gotoTarget();
    }
}

songtickerobj.onTargetReached(){
    if(direction == 1){
       direction = 2;
       songtickerobj.setTargetY(defaulty);
       songtickerobj.setTargetSpeed(slen/speed);
       songtickerobj.gotoTarget();
    } else if(direction == 2) {
       direction = 1;
       songtickerobj.setTargetY(defaulty-sheight+maxheight-3);
       songtickerobj.setTargetSpeed(slen/speed);
       songtickerobj.gotoTarget();
    } else {
       ismoving = songtickerobj.isGoingToTarget();
       if(ismoving) {
          songtickerobj.cancelTarget();
       }
       songtickerobj.setXmlParam("y", System.integerToString(defaulty));
       direction = 1;
    }
}

Songticker.onLeftButtonDblClk(int x, int y) {
	PlDir.showCurrentlyPlayingEntry();
}

Volbar.onSetPosition(int f) {
	f = f / 255 * 100;
	setTempText(System.integerToString(f) + "%");
}

Volbar.onSetFinalPosition(int p) {
	Songticker.setAlternateText("");
}

Seeker.onSetPosition(int p) {
	if (seeking) {
		Float f;
		f = p;
		f = f / 255 * 100;
		Float len = getPlayItemLength();
		if (len != 0) {
			int np = len * f / 100;
			setTempText(integerToTime(np));
    		}
	}
}

Seeker.onLeftButtonDown(int x, int y) {
	seeking = 1;
}

Seeker.onLeftButtonUp(int x, int y) {
	seeking = 0;
	setTempText("");
}

Seeker.onSetFinalPosition(int p) {
	Songticker.setAlternateText("");
}

HintObject.onLeftButtonDown(int x, int y) {
	if (HintObject == Play) setTempText("Play");
	else if (HintObject == Stop) setTempText("Stop");
	else if (HintObject == Pause) setTempText("Pause");
	else if (HintObject == Next) setTempText("Next");
	else if (HintObject == Previous) setTempText("Previous");
	else if (HintObject == minimize) setTempText("Minimize");
	else if (HintObject == winshadeh) setTempText("Horizontal");
	else if (HintObject == winshaden) setTempText("Normal");
	else if (HintObject == cf) setTempText("Crossfade");
	else if (HintObject == shuffle) setTempText("Shuffle");
	else if (HintObject == repeat) setTempText("Repeat");
	else if (HintObject == exit) setTempText("Exit Winamp");
	else if (HintObject == aot) setTempText("Always on top");
}

HintObject.onLeftButtonUp(int x, int y) {
	emptyTempText();
}

setTempText(String txt) {
	Songticker.setAlternateText(txt);
}

emptyTempText() {
	Songticker.setAlternateText("");
}


verticalizeString(String mytxt) {
    slen = strlen(mytxt);
    sheight = slen*charheight;
    vtxt = "";
    for(i=0; i<slen; i++){
       vtxt = vtxt + strmid(mytxt, i, 1) + "\n";
    }

    return vtxt;
}